// Chap26_2.cpp
template <class T>
class Array
{
  protected:
    int nSize;
    T*  ptArray;

  public:
    Array(int nArraySize)
    {
        nSize = nArraySize;
        ptArray = new T[nSize];
    }

    int size()
    {
        return nSize;
    }

    T& operator[](int nIndex)
    {
        if (nIndex < 0 || nIndex >= nSize)
        {
            throw "Range of Array object exceeded";
        }
        return ptArray[nIndex];
    }

int main()
{
    // create an array of ints
    Array<int> arrayOfInts(10);

    int i;
    for (i = 0; i < arrayOfInts.size(); i++)
    {
        arrayOfInts[i] = i;
    }
    return 0;
}

};
